---
obj: application
source: https://www.kali.org/tools/crunch/
repo: https://salsa.debian.org/debian/crunch
---

# crunch
wordlist generator

Usage: `crunch <min-len> <max-len> [<charset string>] [options]`

## Options
| Option                                 | Description                                                                                                                                                                                                                         |
| -------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `-c number`                            | Specifies  the  number  of lines to write to output file, only works if -o START is used                                                                                                                                            |
| `-d numbersymbol`                      | Limits the number of duplicate characters. `-d 2@` limits the lower case alphabet to output like aab and aac. aaa would not be generated as that is 3 consecutive letters of a.                                                     |
| `-e string`                            | Specifies when crunch should stop early                                                                                                                                                                                             |
| `-f /path/to/charset.lst charset-name` | Specifies a character set from the charset.lst                                                                                                                                                                                      |
| `-i`                                   | Inverts the output so instead of aaa,aab,aac,aad, etc you get aaa,baa,caa,daa,aba,bba                                                                                                                                               |
| `-o wordlist.txt`                      | Specifies the file to write the output to, eg: wordlist.txt                                                                                                                                                                         |
| `-s startblock`                        | Specifies a starting string, eg: 03god22fs                                                                                                                                                                                          |
| `-t @,%^`                              | Specifies a pattern, eg: @@god@@@@ where the only the @'s, ,'s, %'s, and ^'s  will change. <br>`@` will insert lower case characters<br>`,` will insert upper case characters<br>`%` will insert numbers<br>`^` will insert symbols |
| `-z gzip, bzip2, lzma, and 7z`         | Compresses  the output from the -o option.  Valid parameters are gzip, bzip2, lzma, and [7z](compression/p7zip.md).                                                                                                                             | 
